Codeforces Round #556(Div.1)
A
容易发现i,i+1至少有一个数出现,于是可以让尽量多的2和奇数出现
#include<bits/stdc++.h>
using namespace std;
int n,s1,s2;
int main()
{
scanf("%d",&n);
for(int i=,x;i<=n;i++)
{
scanf("%d",&x);
if(x==)s1++;else s2++;
}
if(s1==)
{
if(!s2)printf("");
else{
printf("2 1");
for(int i=;i<s2;i++)printf("");
}
}
else if(s1&)
{
for(int i=;i<=s1;i++)printf("1 ");
for(int i=;i<=s2;i++)printf("2 ");
}
else if(s1!=)
{
for(int i=;i<s1;i++)printf("1 ");
for(int i=;i<=s2;i++)printf("2 ");
if(s1)printf("");
}
else{
if(!s2)printf("1 1");
else{
printf("2 1 ");
for(int i=;i<s2;i++)printf("2 ");
printf("");
}
}
}
B
设f[i][j][k]表示第1个串匹配到i,第2个串匹配到j,第3个串匹配到k所用的最小长度,然后每次添加一个字符可以O(250^2)转移另外两维的状态即可。
复杂度:O(q250^2),我比赛时写了个多余的二分变为O(q250^2*logn),不过评测机快+复杂度不满,实测也能通过,手算在1e9以内就没改了
多个log的code
#include<bits/stdc++.h>
using namespace std;
const int N=1e5+;
int n,q,la,lb,lc,p[N],sum[N][],f[][][];
char s[N],a[N],b[N],c[N];
int find(int v,int pos)
{
if(pos>n)return 1e9;
if(sum[n][v]-sum[pos-][v]==)return 1e9;
int L=pos,R=n,mid,ret=1e9;
while(L<=R)
{
mid=L+R>>;
if(sum[mid][v]-sum[pos-][v]==)L=mid+;
else R=mid-,ret=mid;
}
return ret;
}
void del1()
{
for(int i=;i<=lb;i++)
for(int j=;j<=lc;j++)
f[la][i][j]=1e9;
la--;
}
void del2()
{
for(int i=;i<=la;i++)
for(int j=;j<=lc;j++)
f[i][lb][j]=1e9;
lb--;
}
void del3()
{
for(int i=;i<=la;i++)
for(int j=;j<=lb;j++)
f[i][j][lc]=1e9;
lc--;
}
void add1()
{
la++;cin>>a[la];
p[n+]=1e9;
for(int i=n;i>=;i--)if(s[i]==a[la])p[i]=i;else p[i]=p[i+];
for(int i=;i<=lb;i++)
for(int j=;j<=lc;j++)
if(f[la-][i][j]<1e9)
f[la][i][j]=p[f[la-][i][j]+];
else f[la][i][j]=1e9;
for(int i=;i<=lb;i++)
for(int j=;j<=lc;j++)
if(f[la][i][j]<1e9)
{
int pos=i<lb?find(b[i+]-'a',f[la][i][j]+):1e9;
if(pos<1e9)f[la][i+][j]=min(f[la][i+][j],pos);
pos=j<lc?find(c[j+]-'a',f[la][i][j]+):1e9;
if(pos<1e9)f[la][i][j+]=min(f[la][i][j+],pos);
}
}
void add2()
{
lb++;cin>>b[lb];
p[n+]=1e9;
for(int i=n;i>=;i--)if(s[i]==b[lb])p[i]=i;else p[i]=p[i+];
for(int i=;i<=la;i++)
for(int j=;j<=lc;j++)
if(f[i][lb-][j]<1e9)
f[i][lb][j]=p[f[i][lb-][j]+];
else f[i][lb][j]=1e9;
for(int i=;i<=la;i++)
for(int j=;j<=lc;j++)
if(f[i][lb][j]<1e9)
{
int pos=i<la?find(a[i+]-'a',f[i][lb][j]+):1e9;
if(pos<1e9)f[i+][lb][j]=min(f[i+][lb][j],pos);
pos=j<lc?find(c[j+]-'a',f[i][lb][j]+):1e9;
if(pos<1e9)f[i][lb][j+]=min(f[i][lb][j+],pos);
}
}
void add3()
{
lc++;cin>>c[lc];
p[n+]=1e9;
for(int i=n;i>=;i--)if(s[i]==c[lc])p[i]=i;else p[i]=p[i+];
for(int i=;i<=la;i++)
for(int j=;j<=lb;j++)
if(f[i][j][lc-]<1e9)
f[i][j][lc]=p[f[i][j][lc-]+];
else f[i][j][lc]=1e9;
for(int i=;i<=la;i++)
for(int j=;j<=lb;j++)
if(f[i][j][lc]<1e9)
{
int pos=i<la?find(a[i+]-'a',f[i][j][lc]+):1e9;
if(pos<1e9)f[i+][j][lc]=min(f[i+][j][lc],pos);
pos=j<lb?find(b[j+]-'a',f[i][j][lc]+):1e9;
if(pos<1e9)f[i][j+][lc]=min(f[i][j+][lc],pos);
}
}
int main()
{
scanf("%d%d",&n,&q);
scanf("%s",s+);
for(int i=;i<=n;i++)
for(int j=;j<;j++)
sum[i][j]=sum[i-][j]+(j==s[i]-'a');
for(int i=;i<=;i++)
for(int j=;j<=;j++)
for(int k=;k<=;k++)
f[i][j][k]=1e9;
f[][][]=;
while(q--)
{
char ch;int x;
cin>>ch>>x;
if(ch=='+')
{
if(x==)add1();
else if(x==)add2();
else add3();
}
else if(x==)del1();
else if(x==)del2();
else del3();
if(f[la][lb][lc]==1e9)puts("NO");
else puts("YES");
}
}
C
一眼看还以为是动态DP,死都想不出方程,懵了。发现根本不是的,mdzz
据说是ZJOI2007捉迷藏的第二种做法?详见http://www.shuizilong.com/house/archives/bzoj-1095-zjoi2007hide-%E6%8D%89%E8%BF%B7%E8%97%8F/?tdsourcetag=s_pcqq_aiomsg
然后发现答案是将(视为1,)视为0后,求选择序列一段区间并将其分成两段后,后一段减去前一段的最大值即为直径,即求max{s[x3]-2s[x2]+s[x1]},其x1<=x2<=x3,然后可以做线段树,维护5个变量,s[rt]表示节点区间和,tr[rt][0]表示区间答案,tr[rt][1/2]表示最大/小前缀和,tr[rt][3]表示取过x1次后-2s[x2]+s[x1]的最大值,tr[rt][4]表示取过x2后的答案,直接暴力统计在哪一段即可。
#include<bits/stdc++.h>
#define lson l,mid,rt<<1
#define rson mid+1,r,rt<<1|1
using namespace std;
const int N=2e5+;
int n,q,a[N],s[N<<],tr[N<<][];
char str[N];
void modify(int rt,int v){tr[rt][]=,s[rt]=tr[rt][]=tr[rt][]=v,tr[rt][]=tr[rt][]=-v;}
void pushup(int rt)
{
int lc=rt<<,rc=rt<<|;
s[rt]=s[lc]+s[rc];
tr[rt][]=max(max(tr[lc][],tr[rc][]),max(tr[lc][]+s[lc]+tr[rc][],tr[lc][]-s[lc]+tr[rc][]));
tr[rt][]=max(tr[lc][],s[lc]+tr[rc][]);
tr[rt][]=min(tr[lc][],s[lc]+tr[rc][]);
tr[rt][]=max(max(tr[lc][],tr[rc][]-s[lc]),tr[lc][]-*(tr[rc][]+s[lc]));
tr[rt][]=max(max(tr[lc][],tr[rc][]-s[lc]),tr[rc][]+s[lc]-*tr[lc][]);
}
void build(int l,int r,int rt)
{
if(l==r){if(l)modify(rt,a[l]);return;}
int mid=l+r>>;
build(lson),build(rson);
pushup(rt);
}
void update(int k,int v,int l,int r,int rt)
{
if(l==r){modify(rt,v);return;}
int mid=l+r>>;
if(k<=mid)update(k,v,lson);else update(k,v,rson);
pushup(rt);
}
int main()
{
scanf("%d%d",&n,&q),n=(n-)*;
scanf("%s",str+);
for(int i=;i<=n;i++)a[i]=str[i]=='('?:-;
build(,n,);
printf("%d\n",tr[][]);
while(q--)
{
int x,y;scanf("%d%d",&x,&y);
if(a[x]!=a[y])update(x,a[y],,n,),update(y,a[x],,n,),swap(a[x],a[y]);
printf("%d\n",tr[][]);
}
}
D
这题的思路也很神,首先看到n<=70,肯定不是什么常规做法……首先可以连长为A的边形成若干连通块,然后跑一遍最短路,记录连通块经过的状态,保证走长为B的边不经过相同的连通块,由于连通块大小为1的不需要记录,所以可以做到O(35n*2^35*logn),这个显然会T飞掉,但是还有更多的连通块也不需要记录,因为它们不会通过走长为B的边绕回来,就是连通块大小为2、3的连通块,因为绕回来的长度最短为2B,而A<2B(大小为2的),2A<2B(大小为3的)。于是只需要记录>=4的连通块即可,复杂度O(17n*2^17logn),显然不会TLE
#include<bits/stdc++.h>
using namespace std;
const int N=,M=;
struct node{int u,d,S;};
int n,m,cnt,tot,A,B,hd[N],v[],nxt[],w[],f[N],sz[N],bel[N],d[N][M];
bool vis[N][M];
bool operator<(node a,node b){return a.d>b.d;}
priority_queue<node>q;
void adde(int x,int y,int z){v[++cnt]=y,w[cnt]=z,nxt[cnt]=hd[x],hd[x]=cnt;}
int find(int x){return x==f[x]?x:f[x]=find(f[x]);}
void modify(int u,int dis,int S){if(d[u][S]>dis)d[u][S]=dis,q.push((node){u,dis,S});}
int main()
{
scanf("%d%d%d%d",&n,&m,&A,&B);
for(int i=;i<=n;i++)f[i]=i,sz[i]=,bel[i]=-;
for(int i=,x,y,z;i<=m;i++)
{
scanf("%d%d%d",&x,&y,&z),adde(x,y,z),adde(y,x,z);
if(z==A)
{
x=find(x),y=find(y);
if(x!=y)f[y]=x,sz[x]+=sz[y];
}
}
for(int i=;i<=n;i++)
if(bel[i]==-&&sz[find(i)]>)
{
for(int j=i;j<=n;j++)if(find(i)==find(j))bel[j]=tot;
++tot;
}
for(int i=;i<=n;i++)
for(int j=;j<(<<tot);j++)
d[i][j]=1e9;
modify(,,(~bel[])?<<bel[]:);
while(!q.empty())
{
int u=q.top().u,S=q.top().S;q.pop();
if(vis[u][S])continue;
vis[u][S]=;
for(int i=hd[u];i;i=nxt[i])
if(w[i]==A)modify(v[i],d[u][S]+w[i],S);
else if(find(u)!=find(v[i])&&(bel[v[i]]==-||!(S>>bel[v[i]]&)))
modify(v[i],d[u][S]+w[i],S|((~bel[v[i]])?<<bel[v[i]]:));
}
for(int i=,ret;i<=n;i++)
{
ret=1e9;
for(int j=;j<(<<tot);j++)ret=min(ret,d[i][j]);
printf("%d ",ret);
}
}
E
首先一看博弈论,也想不出什么重大结论,就猜是SG函数。然后结论是对所有sg=i的点,令s[k]为所有sg[i]=k的h[i]异或起来的值,若存在s[k]!=0则先手必胜,反之必败。
#include<bits/stdc++.h>
using namespace std;
const int N=2e5+;
int n,m,h[N],q[N],d[N],s[N],vis[N],sg[N];
vector<int>G[N];
int main()
{
scanf("%d%d",&n,&m);
for(int i=;i<=n;i++)scanf("%d",&h[i]);
for(int i=,x,y;i<=m;i++)scanf("%d%d",&x,&y),G[x].push_back(y),d[y]++;
int qs=,qe=;
for(int i=;i<=n;i++)if(!d[i])q[qe++]=i;
while(qs<qe)
{
int u=q[qs++];
for(int i=;i<G[u].size();i++)if(!--d[G[u][i]])q[qe++]=G[u][i];
}
for(int i=n;i;i--)
{
int u=q[i];
for(int j=;j<G[u].size();j++)vis[sg[G[u][j]]]=i;
while(vis[sg[u]]==i)sg[u]++;
s[sg[u]]^=h[u];
}
for(int i=n,u;~i;i--)
if(s[i])
{
for(int j=;j<=n;j++)if(sg[j]==i&&h[j]>(s[i]^h[j]))u=j;
h[u]^=s[i];
for(int j=;j<G[u].size();j++)h[G[u][j]]^=s[sg[G[u][j]]],s[sg[G[u][j]]]=;
puts("WIN");
for(int j=;j<=n;j++)printf("%d ",h[j]);
puts("");
return ;
}
puts("LOSE");
}
result:rank206 rating+=36,手速慢了,没上2200,水平低啊……
Codeforces Round #556(Div.1)的更多相关文章
- Codeforces Round #581(Div. 2)
Codeforces Round #581(Div. 2) CF 1204 A. BowWow and the Timetable 题解:发现,$4$的幂次的二进制就是一个$1$后面跟偶数个$0$. ...
- Codeforces Round #334(div.2)(新增不用二分代码) B
B. More Cowbell time limit per test 2 seconds memory limit per test 256 megabytes input standard inp ...
- Codeforces Round #334(div.2) A
A. Uncowed Forces time limit per test 1 second memory limit per test 256 megabytes input standard in ...
- codeforces Round #389(Div.2)C Santa Claus and Robot(思维题)
题目链接:http://codeforces.com/contest/752/problem/C 题意:给出一系列机器人的行动方向(机器人会走任意一条最短路径),问最少标记几个点能让机器人按这个 路径 ...
- Codeforces Round #626 (Div. 2) B. Count Subrectangles
题目连接:https://codeforces.com/contest/1323/problem/B 题意:给一个大小为n的a数组,一个大小为m的b数组,c数组是二维数组c[i][j]=a[i]*b[ ...
- Codeforces Round #342 (Div 2) 解题报告
除夕夜之有生之年CF第一场 下午从奶奶家回到姥姥家,一看还有些时间,先吃点水果陪姥姥姥爷聊了会儿,再一看表,5:20....woc已经开场20分钟了...于是抓紧时间乱搞.. **A. Guest F ...
- Codeforces Round 1153(div. 2)
这场奇差.ABCD四题.179名. 但是E在现场有213个人做出. 描述一下我在35分钟做完D后的心路历程. 首先看到这道E,第一下想到的是把所有的横向和竖向的整列(行)求出相连的个数. 然后想如何能 ...
- Codeforces Round #345 (Div 2)
最后两题是orzCJK学长帮忙代打的,不过总算是到蓝名了(上次睡迟了,只剩半个小时,结果作大死点开题目看,结果rating掉了100多),还有论代码风格的重要性!!!(没写空格被学长各种D) A题 题 ...
- Codeforces Round #622(Div 2)C2. Skyscrapers (hard version)
题目链接 : C2. Skyscrapers (hard version) 题目描述 : 与上一道题类似,只是数据范围变大, 5e5, 如果用我们原来的方法,铁定是超时的. 考察点 : 单调栈,贪心, ...
随机推荐
- 《新标准C++程序设计》1.7-1.10(C++学习笔记2)
1.内联函数(inline关键字) eg.inline int Max(int a,int b) { if(a>b) return a; return b; } 当编译器处理调用内联函数的语句时 ...
- 05 GUI UGUI
在Unity开发过程中,不论是3D还是2D开发都需要大量的UI界面来配合使用,用来达到更好的效果 GUI:在Unity脚本生命周期回调方法OnGUI中实现,每一帧渲染两次,在OnGUI中的GUI界面元 ...
- Day 10:浅谈正则表达式
正则表达式 以检验扣扣号是否合法为例引入正则表达式 要求:校验QQ号,要求:必须是5~15位数字,0不能开头. 1.没有正则表达式 public class Demo1 { public static ...
- c++程序—变量
#include<iostream> using namespace std; int main() { int a = 10; cout << "a=" ...
- 【2017西安邀请赛:A】XOR(线段树+线性基)
前言:虽然已经有很多题解了,但是还是想按自己的理解写一篇. 思路:首先分析题目 一.区间操作 —— 线段树 二.异或操作 —— 线性基 这个两个不难想,关键是下一步的技巧 “或”运算 就是两个数的二进 ...
- (day 1)创建项目--3【创建应用】
创建步骤 1.打开命令行,进入项目中manage.py的同级目录 2.在命令行输入 python manage.py startapp blog 3.添加应用名到settings.py的INSTALL ...
- DVWA--文件上传
开门见山 1. 准备一个shell <?php echo shell_exec($_GET['cmd']);?> 2. 上传文件 3. 利用shell 4. Burp抓包,1是文件大小,2 ...
- JavaScript 之 数据在内存中的存储和引用
栈和堆 大家都知道,JS中的数据类型包括两种:简单数据类型(String.Number.Boolean.undefined.null)和复杂数据类型(object). 在内存中分为栈区(stack)和 ...
- MySQL的优化与执行
MySQL会解析查询,并创建内部数据结构(解析树),然后对其进行各种优化,包括重写查询.决定表的读取顺序,以及选择合适的索引等.用户可以通过特殊的关键字提示(hint)优化器,影响它的决策过程.也可以 ...
- 吴裕雄--天生自然MySQL学习笔记:MySQL 事务
MySQL 事务主要用于处理操作量大,复杂度高的数据.比如说,在人员管理系统中,你删除一个人员,你即需要删除人员的基本资料,也要删除和该人员相关的信息,如信箱,文章等等,这样,这些数据库操作语句就构成 ...